clear, close all, clc, warning off 
% Argei ligo na trexei 'ypomonh'

I = imread('trapezio.png');     %eisagw thn eikona
I = logical(I(:,:,1));          %epidei thn eisagwi rgb metatrepw se binary
figure, imshow(I)               % optikopoihsh ths eikonas
 
I_transform = zeros(size(I,1),size(I,2));

 

%Parameteres
angle_rad = deg2rad(47);            % H gwnia strofis se rad
scaleY = 0.6;                       % Klimakosi_ston_katakoryfo
scaleX = 0.6;                       % Klimakosi_ston_orizontio
translateX = -300;                  % Metakinhsh ston orizontio
translateY = 400;                   % Metakinhsh ston katakorifo
Sx = 0.8;                           % Paramorfosi ston x
Sy = 0.7;                           % Paramorfosi ston y
 

% Define matrix for Rotation
Matrix_for_rotation = [ cos(angle_rad) sin(angle_rad) 0;
                       -sin(angle_rad) cos(angle_rad) 0;
                           0              0           1];

% Define matrix for Reflection
Matrix_for_reflection = [1  0  0;
                         0 -1  0;
                         0  0  1];                               

% Define matrix for Scale
Matrix_for_scaling = [scaleX   0    0;
                         0   scaleY 0;
                         0     0    1];

% Define matrix for translation
Matrix_for_translate = [1     0     translateX;
                        0     1     translateY;
                        0     0          1    ];

% Define matrix for vertical Shear                               
 Matrix_for_shearY = [1       0     0;
                      Sy      1     0;
                      0       0     1];
 
% Define matrix for horizontal Shear                               
 Matrix_for_shearX = [1      0     0;
                      0      1     0;
                      0      Sx    1];   
  
                                
  
affine_matrix = Matrix_for_translate*Matrix_for_rotation*Matrix_for_scaling*Matrix_for_shearY; % 4 metasxhmatismoi mazi
                               

for i = 1:size(I,1) % grammes
    for j = 1:size(I,2) % sthles
        XY_new = round(affine_matrix*[i;j;1]);
        if XY_new(1) > 0 & XY_new(1) < size(I,1) & XY_new(2) > 0 & XY_new(2) < size(I,2)
            I_transform(XY_new(1), XY_new(2)) = I(i,j);
        end        
    end
end
figure, imshow(I_transform)
