clc, close all, clear, warning off

pkg load image

cd('datasets')
I_rgb = imread('pool.png');
IR = I_rgb(:,:,1);
figure, imshow(IR)

% Sobel Masks
Gx = [1 0 -1;+2 0 -2;1 0 -1];
Gy = [1 2 1; 0 0 0;-1 -2 -1];

I_gradient_x = conv2(IR,Gx);
I_gradient_y = conv2(IR,Gy);

figure, imshow(uint8(I_gradient_x))
figure, imshow(uint8(I_gradient_y))

I_gradient = sqrt(I_gradient_x.^2 + I_gradient_y.^2);

figure, imshow(uint8(I_gradient))

% Ylopoihsh apo function ths matlab
I_edges_matlab = edge(IR,'sobel');
I_gradient_matlab = imgradient(IR,'sobel');
figure, imshow(uint8(I_gradient_matlab))