clear, close all, clc

%Parameteres
angle_rad = deg2rad(47);            % H gwnia strofis se rad
scaleY = 0.6;                       % Klimakosi_ston_katakoryfo
scaleX = 0.6;                       % Klimakosi_ston_orizontio
translateX = -300;                  % Metakinhsh ston orizontio
translateY = 400;                   % Metakinhsh ston katakorifo
Sx = 0.8;                           % Paramorfosi ston x
Sy = 0.7;                           % Paramorfosi ston y

% Define matrix for Rotation
Matrix_for_rotation = [ cos(angle_rad) sin(angle_rad) 0;
                       -sin(angle_rad) cos(angle_rad) 0;
                           0              0           1];

% Define matrix for Reflection
Matrix_for_reflection = [1  0  0;
                         0 -1  0;
                         0  0  1];                               

% Define matrix for Scale
Matrix_for_scaling = [scaleX   0    0;
                         0   scaleY 0;
                         0     0    1];

% Define matrix for translation
Matrix_for_translate = [1     0     translateX;
                        0     1     translateY;
                        0     0          1    ];

% Define matrix for vertical Shear                               
 Matrix_for_shearY = [1       0     0;
                      Sy      1     0;
                      0       0     1];
 
% Define matrix for horizontal Shear                               
 Matrix_for_shearX = [1      0     0;
                      0      1     0;
                      0      Sx    1];   
  
                                
  
