clc, clear, close all, warning off

I_lena_rgb = imread('lena.png');
I_lena_R = I_lena_rgb(:,:,1);

pkg load image

I_edge_roberts = edge(I_lena_R,'Roberts');
I_edge_prewitt = edge(I_lena_R,'Prewitt');
I_edge_sobel = edge(I_lena_R,'Sobel');
I_edge_LoG = edge(I_lena_R,'log');
I_edge_Canny = edge(I_lena_R,'Canny');

figure, imshow(I_lena_R)
title('Initial Lena')
figure, imshow(I_edge_roberts)
title('Roberts')
figure, imshow(I_edge_prewitt)
title('Prewitt')
figure, imshow(I_edge_sobel)
title('Sobel')
figure, imshow(I_edge_LoG)
title('log')
figure, imshow(I_edge_Canny)
title('Canny')

